%TITLE "Prohibit the PrtSc Key- TSR"
%PAGESIZE 50

; Trap Interrupt 09 and prevent users from hitting PrtSc 
; without the shift key
; Written By Carlos M. Valdes
; 250 NW 49th ave
; Miami, Fl. 33126
; (305) 448-2725
;
;NOPRTSC.ASM    (c) 1994

CODE    SEGMENT BYTE PUBLIC

	ASSUME  CS:CODE

	org     100h


Start:
	jmp     install


;CS-relative variables, easily accessible to interrupt handlers

OldInt09       	LABEL DWORD
OldInt09Ofs    	DW ?
OldInt09Seg    	DW ?
Message  	DB "PrtSc now disabled. Use Shift+PrtSc instead.",13,10,"$"

ShiftKeys  	EQU BYTE PTR 17h  	;Addresses in BIOS data area

NewInt09Hndlr PROC FAR
	STI                             ;Interrupts on
	PUSH    AX                      ;Save registers we use
	PUSH    BX
	PUSH    CX
	PUSH    DS
	
	MOV     AX,0040h
	MOV     DS,AX                   ;Address BIOS data area

	IN      AL,60h                  ;Read scan code
	CMP     AL,37h                  ;Is it PrtSc?
	JNE     OldInt09Hndlr          	;If not, jump to old BIOS int 09 handler
	MOV     AL,DS:ShiftKeys    	;Address bios area for shift keys
	MOV     CL,AL                   
	TEST    CL,00001111b            ;Check for shift, cntrl, alt keys
	JZ      short PrtScr            ;Got our key, Let's ignore it

OldInt09Hndlr:                          ;Let old int 09 take care of it
	POP     DS                      ;Restore regs.
	POP     CX
	POP     BX
	POP     AX
	JMP     OldInt09               	;Transfer to old int 09

PrtScr:
	xor     ah,ah
	MOV     CX,AX                   ;Save scanned word in CX reg.
	IN      AL,61h                  ;Read control value from port
	MOV     AH,AL                   ;Save it in AH
	OR      AL,80h                  ;Set 8th bit
	OUT     61h,AL                  ;Reset keyboard chip
	MOV     AL,AH                   ;Get saved value
	OUT     61h,AL                  ;Enable keyboard chip
	CLI                             ;Stop interrupts temporarly
	MOV     AL,20h                  ;Signal End of interrupt
	OUT     20h,AL                  ;To interrupt controller


	STI                             ;Turn Interrupts back on
	POP     DS                      ;Restore registers
	POP     CX
	POP     BX
	POP     AX
	IRET                            ;Return to oblivion
NewInt09Hndlr ENDP

;*********************************************************** Install

Install:
	MOV     AX,3509h                ;Get current int 9 handler
	INT     21h
	MOV     OldInt09Ofs,BX         	;Save it in CS-relative variables
	MOV     OldInt09Seg,ES		;To ease access in int. routine
	PUSH    DS			;Data Segment is now Code Segment
	PUSH    CS
	POP     DS
	MOV     DX,offset NewInt09Hndlr	;Address of our routine
	MOV     AX,2509h                ;Install new int 9
	INT     21h
   	MOV 	AH,9			;Display Init message
   	MOV 	DX,OFFSET CS:Message	;
   	INT 	21h			;
	POP     DS
	mov     dx,offset Install
	int     27h			;    Terminate and keep resident

CODE    ENDS
	END   Start


